#! /usr/local/bin/perl
# 
# /*   $Id: bcnuagent.cgi,v 1.4 1999/06/29 12:32:51 jap Exp jap $
#
# *    Copyright (c) 1998 John Phillips
# *
# *    You may distribute under the terms of the Artistic License
# *
# */
#
require "bcnu.inc";
require "bcnulib.pl";

&methodparse;

$navigate=&navigate();
$showkey=&showkey();

$host=$in{"host"};
$inagent=$in{"agent"};
$login=$in{"login"};
$password=$in{"password"};
$reason=$in{"reason"};
$submit=$in{"submit"};
#
# main
#

$errlevel=0;
if ($login) {
   if (&validlogin($login,$password)) {
	if ($submit =~ /Ignore/) {
		open(IGNORE,">$BCNUHOME/flags/$host.ignore")  || &bcnuerror("$host", "can't create $BCNUHOME/flags/$host.ignore");
		print IGNORE "$now:$login:$reason\n";
		close (IGNORE);
	}
	elsif ($submit =~ /Notice/) {
		if ( -r "$BCNUHOME/flags/$host.ignore") {
			unlink("$BCNUHOME/flags/$host.ignore") || &bcnuerror("$host", "can't remove $BCNUHOME/flags/$host.ignore");
			undef $login;
			undef $reason;
			}
	}
   }
   else
	{
	&bcnuerror("$host", "Invalid password entered");
	}
}


if ($inagent) {

	$agent="$inagent";	
	&agentdetail ($host,$agent);
	&agent_info;
	print &printhdr;
	print &header("$host - Agent ($inagent)",$errlevel,2);
	print $agdisp;
	print &ignoreform;
	print &footer();
}
else	{

	&getagents($host);
	&agenthost ($host);
	&agent_info;
	print &printhdr;
	print &header("$host - Agent Summary",$errlevel,2);
	print $agdisp;
	print $agalertinfo;
	print &ignoreform;
	print &footer();
}


sub ignoreform {

if (open(IGNORE,"$BCNUHOME/flags/$host.ignore")) {
	$flagignore=<IGNORE>;
	chop $flagignore;
	($done,$login,$reason) = split(":",$flagignore);
	close(IGNORE);
	$ignore="Notice errors for $host";
	}

else
	{
	$ignore = "Ignore errors for $host" ;
	}

$form = <<"Endofform";
</TABLE>
<HR WIDTH=75%>
<TABLE BORDER=0>
<FORM METHOD="POST"> 
<INPUT TYPE=HIDDEN NAME="host" VALUE="$host">
<INPUT TYPE=HIDDEN NAME="agent" VALUE="$agent">
<TR>	<TH $DEFCELL>Login</TH>
	<TD><INPUT TYPE="text" NAME="login" SIZE=12 VALUE="$login"></TD>
	
</TR>
<TR>	<TH $DEFCELL>Password</TH>
	<TD><INPUT TYPE="password" NAME="password" SIZE=12 VALUE=""></TD>
</TR>
<TR>	<TH $DEFCELL>Reason $done</TH>
	<TD><TEXTAREA COLS=50 ROWS=4 NAME="reason">$reason</TEXTAREA>
</TR>
<TR>	<TD Align=CENTER COLSPAN=2><INPUT TYPE="submit" NAME="submit" VALUE="$ignore">
</TR>
</FORM>
</TABLE>
<P>

Endofform

return ($form);
}

sub validlogin	{

local ($login,$password) =@_;

if ( ! $BCNUPASSWD ) {
	return(1);
}

open (INPASSWD,$BCNUPASSWD) || &bcnuerror("$host", "Can't open password file $BCNUPASSWD.\n");

while (<INPASSWD>) {
	chop;
	($pwlogin,$pwpassword) = split(":");

	if ($pwlogin eq $login) {
		$ckpass=crypt($password,$pwpassword);
		if ($ckpass eq $pwpassword) {
			return(1);
			}
		
		}
	}	
close(INPASSWD);
return (0);
}

sub agent_info {

eval { require "$BCNUHOME/data/hostinfo"};

if ( ! $hostinfo{$host} ) { 
	$hostinfo{$host} = "No details";
	}
if ( ! $hostemail{$host} ) { 
	$hostemail{$host} = $defemail;
	}
if ( ! $hostpager{$host} ) {
        $hostpager{$host} = $defpager;
        }
$agalertinfo = <<"Endofaginfo";
</TABLE><HR WIDTH=75%>
Information about this system ($host)
<TABLE BORDER=1>
<TR><TD $ECELL>Description<TD BGCOLOR=#ffff80>$hostinfo{$host}</TR>
<TR><TD $ECELL>System Type<TD BGCOLOR=#ffff80>$bcnu_host_type{$platform{$host}}</TR>
<TR><TD $ECELL>Email alerts<TD BGCOLOR=#ffff80>$hostemail{$host}</TR>
<TR><TD $ECELL>Pager alerts<TD BGCOLOR=#ffff80>$hostpager{$host}</TR>
</TABLE><TABLE BORDER=1>
Endofaginfo
}
